/**
  *  \file server/objcmd.h
  *  \brief Server: Object Commands
  */
#ifndef C2SERVER_SERVER_OBJCMD_H
#define C2SERVER_SERVER_OBJCMD_H

#include "cpluslib/string.h"
#include "cpluslib/ptrvector.h"

class IntArgBlock;
class ServerObjectWriter;

class ServerObjectCommandHandler {
 public:
    virtual ~ServerObjectCommandHandler();
    virtual void processCommand(string_t cmd, IntArgBlock& args, ptr_vector<ServerObjectWriter>& result) = 0;
};

class ServerPlanetCommandHandler : public ServerObjectCommandHandler {
    int pid;
 public:
    ServerPlanetCommandHandler(int pid);
    void processCommand(string_t cmd, IntArgBlock& args, ptr_vector<ServerObjectWriter>& result);
};

class ServerShipCommandHandler : public ServerObjectCommandHandler {
    int sid;
 public:
    ServerShipCommandHandler(int sid);
    void processCommand(string_t cmd, IntArgBlock& args, ptr_vector<ServerObjectWriter>& result);
};

#endif
