/**
  *  \file server/queryout.h
  */
#ifndef C2SERVER_SERVER_QUERYOUT_H
#define C2SERVER_SERVER_QUERYOUT_H

class JsonWriter;

class ServerQueryWriter {
 public:
    virtual ~ServerQueryWriter()
        { }
    virtual void write(JsonWriter& w) = 0;
};

class ServerShipFCWriter : public ServerQueryWriter {
    int sid;
 public:
    ServerShipFCWriter(int sid)
        : sid(sid)
        { }
    void write(JsonWriter& w);
};

class ServerPlanetFCWriter : public ServerQueryWriter {
    int pid;
 public:
    ServerPlanetFCWriter(int pid)
        : pid(pid)
        { }
    void write(JsonWriter& w);
};

class ServerShipMissionWriter : public ServerQueryWriter {
    int sid;
 public:
    ServerShipMissionWriter(int sid)
        : sid(sid)
        { }
    void write(JsonWriter& w);
};

#endif
